/*	
 *	framds21.c
 *
 *	RAM]FXLC`֐iyrȂEeNX`Ȃj
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Mon Aug  2 05:00:00 JST 2004 Naoyuki Sawa
 *	- clipren3.cړĂ܂B
 *	* Sat Aug 25 23:05:34 JST 2007 Naoyuki Sawa
 *	- AZu܂B
 */
#include "clip.h"

/*****************************************************************************
 *	
 *****************************************************************************/

#ifdef REND_NOASM
void
draw_scanline_woz_color(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param)
{
	unsigned char* vptr;	/* J[obt@|C^     */
	int nx;			/* ݂̃XLC̒ */
	int n;			/* ݂̕ӂ̎csNZ   */
	const RENDVERTEX* tmp;
	int ofs;

	/* m :v0 -> v1:E Ƃ܂B */
	if(v0->x > v1->x) {
		tmp = v0;
		      v0 = v1;
		           v1 = tmp;
	}

	/* n_AhX߂܂B */
	ofs = param->surface_w * v0->y + v0->x;
	vptr = param->surface_vbuff + ofs;

	/* 厲DDAZbgAbvB */
	nx = v1->x - v0->x;
	if(nx == 0) return; /* _Ȃ`܂B */

	/* DDA[vB */
	n = nx;
	do {
		/* eNX`ȂAtFCX̔wiFŕ`܂B */
		*vptr = param->back_color;
		/* obt@|C^i߂܂B */
		vptr++;
	} while(--n); /* E[sNZ͕`Ȃ̂ŁAvfNgłB */
}
#else /*REND_NOASM*/
	asm("
	.code
	.align 1
	.global draw_scanline_woz_color
	;// IN:
	;// %r12     = v0
	;// %r13     = v1
	;// %r14     = param
draw_scanline_woz_color:
	;// USAGE:
	;// none

	;// m :v0 -> v1:E Ƃ܂B
	xld.uh	%r4, [%r12+0]				;// v0->x
	xld.uh	%r5, [%r13+0]				;// v1->x
	cmp	%r4, %r5
	xjrule	__draw_scanline_woz_color_swap
	xor	%r12, %r13
	xor	%r13, %r12
	xor	%r12, %r13
__draw_scanline_woz_color_swap:
	;// %r12 = v0
	;// %r13 = v1

	;// n_AhX߂܂B
	xld.uh	%r4, [%r14+0]				;// param->surface_w
	xld.w	%r5, [%r14+4]				;// param->surface_vbuff
	xld.uh	%r6, [%r12+0]				;// v0->x
	xld.uh	%r7, [%r12+2]				;// v0->y
	add	%r5, %r6
	mltu.h	%r4, %r7
	ld.w	%r4, %alr
	add	%r4, %r5
	;// %r4 = vptr
	;// %r6 = v0->x

	xld.ub	%r12, [%r14+24]				;// param->back_color
	;// %r12 = back_color

	;// 厲DDAZbgAbvB
	xld.uh	%r5, [%r13+0]				;// v1->x
	xjp.d	__draw_scanline_woz_color_next
	sub	%r5, %r6				; *delay*
	;// %r5     = n
	;// %psr(Z) = n==0

	;// DDA[vB
__draw_scanline_woz_color_loop:
	ld.b	[%r4]+, %r12				;// *vptr++
	;// ͂n܂܂B
	;// En==0Ȃ΁A`ɔ܂B
	;//   n=(n-1)ɂȂ܂A_~[łB
	;// En!=0Ȃ΁An=(n-1)AtO(n-1)==0𔽉fāA[v܂B
	;// 2ڂɂ֗ƂAtOێĂ邱Ƃ𗘗p܂B
	;// [vJE^ƃtO͑Õ[v̒xXbgŐɕωĂA
	;// ̃[vł̌ʂQƂ킯łB
__draw_scanline_woz_color_next:
	xjrne.d	__draw_scanline_woz_color_loop
	sub	%r5, 1					; *delay*
	;// %r5     = (n-1)
	;// %psr(Z) = (n-1)==0

	ret
	");
#endif /*REND_NOASM*/
